unit ModDisplay;
// $Todo: OpelGL *grin*
{ $define YUY2}

interface
 uses ModMain, Windows, SysUtils, Classes, Graphics,hyper64,UOverlay,directdraw;

type
  TRGB        = Record r,g,b:Byte End;
  TPalette    = Array[0..255] of TRGB;

  TYUV        = Record Y0,U,Y1,V:Byte end;
  TYUVPalette = Array[0..255] of TYUV;

  TMode       = (GDI,DDRAW,OVL);

  TOutput=class
   private
    fCanvas:TCanvas;
    fBitmap:TBitmap;          // Maindisplay GDI

    fHyper: THyper64;         // Display DirectX
    fSurface: TBuffer64;

    // Overlay
    fColorkey: DWord;         // Overlay-Colorkey;
    fOVLCol:TYuvPalette;      // Overlay-YUY2-Palette
    fOverlay: TDDrawXOverlay; // Overlay
    fOdd:Boolean;

    fPalette:TPalette;
    fHeight: Word;
    fWidth: Word;
    fSpeccyline: array[0..191] of word;
    fFlashstat:Boolean;
    ftop,fleft: Word;
    fBorder: Word;

    fReverse_attr:array[0..127] of byte;
    fVga_h_nib:array[0..15,0..127] of longint;
    fMode: TMode;
    fSkip,Skipped: Byte;
    fFlash:Boolean;

    procedure SetPalette(Pal:TPalette);
    procedure SetHeight(Height:Word);
    procedure SetWidth(Width:Word);

    procedure AdjustDim(BorderEmu:Boolean);
    procedure MakeTable;
    function CBGR(Color:Longint;B:Byte):longint;

    procedure calcovlpal;
    procedure putYUVpixel(x,y:DWord;Color:word);

   public
    constructor create(Canvas:TCanvas;Borderemu:Boolean);overload;
    constructor create(Handle:HWND;Width,Height:Word;Borderemu:Boolean);overload;
    constructor create(Handle:HWND;Width,Height,Colorkey:DWord;Borderemu:Boolean);overload;
    destructor Destroy;

    procedure PaintColorKey;
    procedure Setborder(Y:Integer);
    procedure Updateline(Y:Integer);
    procedure Repaint;
    property Palette: TPalette read fPalette write SetPalette;

    property Height: Word read fHeight write SetHeight;
    property Width: Word read fWidth write SetWidth;
    property Left: Word read FLeft;
    property Top: Word read FTop;
    property Flash_Status: Boolean read fFlashStat write fFlashStat;
    property Border: Word read fBorder write FBorder;
    property Skip: Byte read fSkip write fSkip;

    property Mode: TMode read FMode;
    property Flash: Boolean read fFlash write FFlash;
  end;

  const YaseCol:array[0..15] of TRGB =(
      (R:000;G:000;B:000),
      (R:000;G:000;B:160),
      (R:220;G:000;B:000),
      (R:228;G:000;B:180),
      (R:000;G:212;B:000),
      (R:000;G:212;B:212),
      (R:208;G:208;B:000),
      (R:200;G:200;B:200),
      (R:000;G:000;B:000),
      (R:000;G:000;B:172),
      (R:240;G:000;B:000),
      (R:252;G:000;B:220),
      (R:000;G:240;B:000),
      (R:000;G:252;B:252),
      (R:252;G:252;B:000),
      (R:252;G:252;B:252));

var
  display: TOutput;

implementation

procedure toutput.maketable;
var v,x,y,z:integer;
    fore_attrib,back_attrib:array[0..255] of byte;
    qtemp:Quadruple;
    Pal:TPalette;
begin
 // Create Table
 v:=0;
 for x:=0 to 2 do
   for y:=0 to 7 do
     for z:=0 to 7 do
      begin
       fSpeccyline[v]:=x shl 11+y shl 5+z shl 8;
       inc(v);
      end;

 for x:=0 to 255 do
  begin
   y:=x and 7; (* fore *)
   z:=(x and 56) shr 3; (* back *)
   if y=0 then y:=y or 8;
   if z=0 then z:=z or 8;

   if x and 64>0 then
    begin
     y:=y or 8;
     z:=z or 8;
    end;
    fore_attrib[x]:=y;
    back_attrib[x]:=z;
  end;

 for x:=0 to 15 do
  begin
   for y:=0 to 127 do
    begin
     if x and 1>0 then
      qtemp.b4:=fore_attrib[y]
     else
      qtemp.b4:=back_attrib[y];

     if x and 2>0 then
      qtemp.b3:=fore_attrib[y]
     else
      qtemp.b3:=back_attrib[y];

     if x and 4>0 then
      qtemp.b2:=fore_attrib[y]
     else
      qtemp.b2:=back_attrib[y];

     if x and 8>0 then
      qtemp.b1:=fore_attrib[y]
     else
      qtemp.b1:=back_attrib[y];
      fvga_h_nib[x][y]:=qtemp.Q;
    end;
  end;

 for x:=0 to 127 do
  begin
   y:=(x and 7) shr 3;
   z:=(x and 56) shr 3;
   fReverse_attr[x]:=(x and 64) or y or z;
  end;

 For X:=low(YaseCol) to high(YaseCol) do Pal[X]:=YaseCol[X];
 Palette:=Pal;
end;

procedure toutput.PaintColorKey;
var Clientrect:TRect;
begin
 if not assigned(foverlay) then exit;
 foverlay.CalculateRect(ClientRect);
 foverlay.PaintColorKey(ClientRect, fColorKey);
end;

procedure toutput.AdjustDim(Borderemu:Boolean);
begin
  if borderemu then
  begin ftop:=32;fleft:=32; end else
  begin ftop:=0;fleft:=0; end;
end;

procedure toutput.calcovlpal;
var x:integer; // Hmm I think the formula is not correct ;?
begin
 for x:=low(Palette) to High(Palette) do
   with Palette[x],fovlcol[x] do
     begin
      Y0:= round(0.299*R + 0.587*G + 0.114*B);
       U:= round(128.0 - 0.1684*R - 0.3316*G + 0.5*B);
      Y1:= round(0.299*R + 0.587*G + 0.114*B);
       V:= round(128.0 + 0.5*R - 0.4187*G - 0.0813*B);
      end;
end;

constructor toutput.create(Handle:HWND;Width,Height,Colorkey:DWord;Borderemu:Boolean);
begin
 Adjustdim(Borderemu);
 //VideoWidth:=256+fleft shl 1;VideoHeight:=192+ftop shl 1;
{$IFDEF YUY2}
  VideoFormat:=makefourcc('Y','U','Y','2');
{$ELSE}
  VideoFormat:=makefourcc('U','Y','V','Y');
{$ENDIF}

 foverlay:=TDDrawXOverlay.create(Handle,
              192+ftop shl 1,256+fleft shl 1,VideoBitCount,VideoFormat);

 fColorkey:=Colorkey;
 fWidth:=Width;
 fHeight:=Height;
 fMode:=OVL;
 Maketable;
 CalcOvlPal;
end;

constructor toutput.create(Handle:HWND;Width,Height:Word;Borderemu:Boolean);
begin
 Adjustdim(Borderemu);
 fhyper:=thyper64.Create(handle,width,height);
 fsurface:=Tbuffer64.create(fhyper,256+fleft shl 1,192+ftop shl 1,true);
 fWidth:=Width;
 fHeight:=Height;
 fMode:=DDRAW;
 Maketable;
end;

constructor toutput.create(Canvas:TCanvas;Borderemu:Boolean);
begin
 Adjustdim(Borderemu);
 fcanvas:=Canvas;
 fbitmap:=TBitmap.create;
 fMode:=GDI;

 with fbitmap do
 begin
  Height:=192+ftop shl 1;
  Width:=256+fleft shl 1;
  PixelFormat:=pf8bit;

  fWidth:=Width;
  fHeight:=Height;
 end;
 MakeTable;
end;

destructor tOutPut.Destroy;
begin
 if assigned(fbitmap) then fbitmap.Destroy;
 if assigned(fsurface) then fsurface.Destroy;
 if assigned(fhyper) then fhyper.Destroy;
 if assigned(foverlay) then foverlay.Destroy;
end;

procedure TOutPut.SetPalette(Pal:TPalette);
var
  col: PLogPalette;
  hpal: HPALETTE;
  i: Integer;
begin
 fpalette:=pal;calcOvlPal;

 if not assigned(fbitmap) then exit;
  col := nil;
  try
    GetMem(col, sizeof(TLogPalette) + sizeof(TPaletteEntry) * 255);
    col.palVersion := $300;
    col.palNumEntries := 256;
    for i := low(Pal) to high(Pal) do
    with Pal[i] do
    begin
      col.palPalEntry[i].peRed := r;
      col.palPalEntry[i].peGreen := g;
      col.palPalEntry[i].peBlue := b;
    end;
    hpal := CreatePalette(col^);
    if hpal <> 0 then fBitmap.Palette := hpal;
  finally
    FreeMem(col);
  end;
end;

function toutput.CBGR(Color:Longint;B:Byte):longint;
var q:Quadruple absolute Color;
    C:Byte;
begin
 case b of
  0: c:=q.b1;
  1: c:=q.b2;
  2: c:=q.b3;
  3: c:=q.b4;
 end;
 with fPalette[c] do result:=fhyper.rgb(r,g,b);
end;

function getbit(Color:Longint;B:Byte):longint;
var q:Quadruple absolute Color;
begin
  case b of
  0: result:=q.b1;
  1: result:=q.b2;
  2: result:=q.b3;
  3: result:=q.b4;
 end;
end;

procedure toutput.putYUVpixel(x,y:DWord;Color:word);
var offset:DWord;
    C: record h,l:byte end;
begin
 offset:=(x+y*foverlay.width) shl 1;
 fodd:=not odd(x);
 with fovlcol[color] do
 {$IFDEF YUY2}
  if fodd then
   begin
    c.l:=Y0;
    c.h:=U;
   end else
   begin
    c.l:=Y1;
    c.H:=V;
   end;
 {$ELSE}
   if fodd then
   begin
    c.l:=U;
    c.h:=Y0;
   end else
   begin
    c.l:=V;
    c.H:=Y1;
   end;
 {$ENDIF}
 with foverlay do
 begin
  pchar(videomemory)[offset]:=char(c.l);//inc(offset);
  pchar(videomemory)[offset+1]:=char(c.h);
 end;
end;

procedure TOutPut.Setborder(Y:Integer);
var color,xmax:longint;
    x:integer;
begin
 xmax:=256+fleft shl 1;
 case fmode of
  GDI:  fillchar(fbitmap.scanline[y]^,xmax,border);
  DDraw: with fPalette[border] do
         begin
          color:=fhyper.rgb(r,g,b);
          fsurface.HLine(0,xmax,y,color);
         end;
  OVL: for x:=0 to xmax do putYUVpixel(x,y,border);
 end;
end;

procedure TOutput.updateline(Y:Integer);
var bitmap, farbepos:word;
    i, x,color, attr, data:Byte;
    offs:Word;
    scanline:PBytearray;
    value:Longint;
begin
   if assigned(fbitmap) then Scanline:=fbitmap.scanline[y+ftop];

   if (fleft>0) or (ftop>0) then // Realborder
   begin
    if (y<0) or (y>191) then begin setborder(y+ftop);exit;end;
    case fmode of
     gdi: if assigned(fbitmap) then
          begin
           fillchar(scanline^[0],fleft,border);
           fillchar(scanline^[256+fleft],fleft,border);
          end;
     DDraw: with fPalette[border] do
            begin
             value:=fhyper.rgb(r,g,b);offs:=256+fleft;
             fsurface.HLine(0,fleft-1,y+ftop,value);
             fsurface.Hline(offs,offs+fleft,y+ftop,value);
            end;
     Ovl: for offs:=0 to fleft-1 do
             begin
              putYUVpixel(offs,y+ftop,border);
              putYUVpixel(offs+256+fleft,y+ftop,border);
             end;
    end;
   end;
   bitmap:=fSpeccyline[y];
   offs:=fleft;
   farbepos:=6144 or ((y and 248) shl 2);

   for x:=0 to 31 do
    begin
     color:=gRAMPage[glUseScreen, farbepos];inc(farbepos);
     attr:=color and 127;

     if flash then
     begin
      if (color and 128>0) and (fFlashstat) then
       attr:=fReverse_attr[attr];
     end;
     
      data:=gRAMPage[glUseScreen, bitmap];inc(bitmap);

      case fmode of
       GDI: begin
             move(fVga_h_nib[(data and $F0) shr 4][attr],scanline^[offs],4);inc(offs,4);
             move(fVga_h_nib[data and $0F][attr],scanline^[offs],4);inc(offs,4);
            end;
       DDRAW: begin
               value:=fVga_h_nib[(data and $F0) shr 4][attr];
               for i:=0 to 3 do fSurface.putpixel(offs+i,y+ftop,cBGR(value,i));
               inc(offs,4);
               value:=fVga_h_nib[data and $0F][attr];
               for i:=0 to 3 do fSurface.putpixel(offs+i,y+ftop,cBGR(value,i));
               inc(offs,4);
              end;
       OVL: begin
               value:=fVga_h_nib[(data and $F0) shr 4][attr];
               for i:=0 to 3 do putYUVpixel(offs+i,y+ftop,getbit(value,i));
               inc(offs,4);
               value:=fVga_h_nib[data and $0F][attr];
               for i:=0 to 3 do putYUVpixel(offs+i,y+ftop,getbit(value,i));
               inc(offs,4);
            end;
      end;
    end;
end;

procedure TOutput.Repaint; // Lame :)
var DestinationRect:TRect;
    value:dword;
begin
 if fskip>0 then
  begin
   skipped:=(skipped+1) mod fskip;
   if skipped>0 then exit;
  end;
 case fMode of
  GDI: fcanvas.StretchDraw(rect(0,0,fwidth,fheight),fBitmap);//bitblt(fcanvas.handle,0,0,fwidth,fheight,fbitmap.canvas.handle,0,0,srccopy);
  DDRAW: fsurface.flip(false); //Vsync!
  OVL: if assigned(foverlay) then
       begin
        foverlay.CalculateRect(DestinationRect);
        foverlay.updateoverlay(@Destinationrect,fColorkey);
       end;
 end;
end;

procedure TOutput.SetHeight(Height:Word);
begin
 fHeight:=Height;Repaint;
end;

procedure TOutput.SetWidth(Width:Word);
begin
 fWidth:=Width;Repaint;
end;
end.
