// well here it is:
// 1st. initialising
// 2nd. PaintColorkey only when moving window
// 3rd. Paint Data into Videopointer
// 4th. having fun..
unit UOverlay;

interface uses windows,classes,directdraw;

const VideoBitCount:integer= 16;
      VideoColorKey:integer= $FEF0FE;
      VideoFormat:integer=$32595559; // YUY2
      VideoHeight:integer= 576;
      VideoWidth:integer= 768;

type TDDrawXOverlay=class
      private
        FDirectDrawClipper:IDIRECTDRAWCLIPPER;
        FDirectDraw:IDIRECTDRAW;
        FDirectDraw2:IDIRECTDRAW;
        FDirectDrawOverlay:IDIRECTDRAWSURFACE;
        FDirectDrawSurface:IDIRECTDRAWSURFACE;
        FHandle:HWND;
        FPitch:DWORD;
        fWidth,fHeight:Dword;
        fSourceRect:TRect;
      public
       VideoMemory:pointer;
       constructor create(Winhandle:Hwnd;
                          OverlayHeight,OverlayWidth,
                          OverlayBitCount,OverlayFormat:DWord);
       destructor Destroy;

       function UpdateOverlay(SourceRect,DestinationRect:Prect;
                       OverlayColorKey:DWORD):HRESULT;overload;
       function UpdateOverlay(DestinationRect:Prect;
                       OverlayColorKey:DWORD):HRESULT;overload;
       function PaintColorKey(WindowRect:TRECT;OverlayColorKey:DWORD):HRESULT;
       Function MoveOverlay(DestinationPoints:TPOINT):HRESULT;
       procedure CalculateRect(Var WindowRect,ClientRect:TRect);overload;
       procedure CalculateRect(Var ClientRect:TRect);overload;

       property handle:HWnd read FHandle;
       property Pitch:DWord read FPitch;
       property Width:Dword read fWidth;
       property Height:DWord read fHeight;
     end;



implementation


Function TDDrawXOverlay.MoveOverlay(DestinationPoints:TPOINT):HRESULT;
begin
 if (FDirectDrawOverlay = NIL) then
  result:=DDERR_GENERIC else
  result:=FDirectDrawOverlay.SetOverlayPosition(DestinationPoints.x, DestinationPoints.y);
end;

procedure TDDrawXOverlay.CalculateRect(Var WindowRect,ClientRect:TRect);
begin
 GetWindowRect(FHandle, WindowRect);
 GetClientRect(FHandle,  ClientRect);
 ClientToScreen(FHandle, ClientRect.Topleft);
 ClientToScreen(FHandle, ClientRect.bottomright);
end;

procedure TDDrawXOverlay.CalculateRect(Var ClientRect:TRect);
begin
 try
  GetClientRect(FHandle,  ClientRect);
  ClientToScreen(FHandle, ClientRect.Topleft);
  ClientToScreen(FHandle, ClientRect.bottomright);
 except
 end;
end;

constructor TDDrawXOverlay.Create(Winhandle:Hwnd;
                                   OverlayHeight,OverlayWidth,
                                   OverlayBitCount,OverlayFormat:DWord);
var ClientRect,WindowRect:Trect;
    DXResult:HRESULT ;
    DDSurfaceDesc2:TDDSURFACEDESC;
    s:String;
begin
        FDirectDrawOverlay:= NIL;
        FDirectDrawSurface:= NIL;
        FDirectDraw2:= NIL;
        FDirectDraw:= NIL;

        VideoMemory:= NIL;
        Fhandle:=winhandle;


        CalculateRect(WindowRect,ClientRect);
        MoveWindow(FHandle,
                   GetSystemMetrics(SM_CXSCREEN) div 2 - OverlayWidth div 2,
                   GetSystemMetrics(SM_CYSCREEN) div 2 - OverlayHeight div 2,
                   OverlayWidth + ClientRect.left - WindowRect.left + WindowRect.right - ClientRect.right,
                   OverlayHeight,false);

        DXResult:= DirectDrawCreate(NIL, FDirectDraw, NIL);
        if DXResult<>DD_OK then
        begin
         // TODO Error message
         FHandle:= 0;
         exit;
        end;

        DXResult:= FDirectDraw.QueryInterface(IID_IDirectDraw2, FDirectDraw2);
        IF DXResult <> DD_OK then
        begin
                // TODO Error message
                FHandle:= 0;
                exit;
        end;

        DXResult:= FDirectDraw2.SetCooperativeLevel(0, DDSCL_NORMAL);
        IF DXResult <> DD_OK then
        begin
                // TODO Error message
                FHandle:= 0;
                exit;
        end;

        ZeroMemory(@DDSurfaceDesc2, sizeof(DDSURFACEDESC2));

    DDSurfaceDesc2.dwSize:= sizeof(DDSURFACEDESC2);
    DDSurfaceDesc2.dwFlags:= DDSD_CAPS;
    DDSurfaceDesc2.ddsCaps.dwCaps:= DDSCAPS_PRIMARYSURFACE;

    DXResult:= FDirectDraw2.CreateSurface(DDSurfaceDesc2, FDirectDrawSurface, NIL);
    s:=ddErrorString(DXResult);
    IF DXResult <> DD_OK then
    begin
                // TODO Error message
                FHandle:= 0;
                exit;
    end;

        ZeroMemory(@DDSurfaceDesc2, sizeof(DDSURFACEDESC2));
        DDSurfaceDesc2.dwSize:= sizeof(DDSURFACEDESC2);
    DDSurfaceDesc2.dwFlags:= DDSD_CAPS or DDSD_HEIGHT or DDSD_WIDTH or DDSD_PIXELFORMAT;
    DDSurfaceDesc2.ddsCaps.dwCaps:= DDSCAPS_OVERLAY;
    DDSurfaceDesc2.dwHeight:= OverlayHeight;
    DDSurfaceDesc2.dwWidth:= OverlayWidth;
    DDSurfaceDesc2.ddpfPixelFormat.dwSize:= sizeof(TDDPIXELFORMAT);
    DDSurfaceDesc2.ddpfPixelFormat.dwFlags:= DDPF_FOURCC;
    DDSurfaceDesc2.ddpfPixelFormat.dwFourCC:= OverlayFormat;
    DDSurfaceDesc2.ddpfPixelFormat.dwYUVBitCount:= OverlayBitCount;

    DXResult:= FDirectDraw2.CreateSurface(DDSurfaceDesc2, FDirectDrawOverlay, NIL);
    IF DXResult <> DD_OK then
    begin
                // TODO Error message
                FDirectDrawSurface:= NIL;
                FHandle:= 0;
                exit;
    end;

    ZeroMemory(@DDSurfaceDesc2, sizeof(DDSURFACEDESC2));
    DDSurfaceDesc2.dwSize:= sizeof(DDSURFACEDESC2);

    DXResult:= FDirectDrawOverlay.Lock(NIL, DDSurfaceDesc2, DDLOCK_WAIT, 0);
    IF DXResult <> DD_OK then
    begin
                // TODO Error message
                FDirectDrawOverlay:=NIL;
                FDirectDrawSurface:=NIL;

                FHandle:= 0;
                exit;
    end;

    if (DDSurfaceDesc2.dwFlags and DDSD_PITCH)>0 then
     FPitch:= DDSurfaceDesc2.lPitch else
     FPitch:= DDSurfaceDesc2.dwWidth * 2;

     VideoMemory:= DDSurfaceDesc2.lpSurface;

        DXResult:= FDirectDrawOverlay.Unlock(NIL);
        IF DXResult <> DD_OK then
        begin

                // TODO Error message
                FDirectDrawOverlay:= NIL;
                FDirectDrawSurface:= NIL;
                VideoMemory:= NIL;
                FHandle:= 0;
                exit;
        end;

        DXResult:= FDirectDraw2.CreateClipper(0, FDirectDrawClipper, NIL);
        IF DXResult <> DD_OK then
        begin
                // TODO Error message
                FDirectDrawOverlay:= NIL;
                FDirectDrawSurface:= NIL;
                VideoMemory:= NIL;
                FHandle:= 0;
                exit;
        end;

        DXResult:= FDirectDrawClipper.SetHWnd(0, FHandle);
        IF DXResult <> DD_OK then
        begin
                // TODO Error message
                FDirectDrawClipper:= NIL;
                FDirectDrawOverlay:= NIL;
                FDirectDrawSurface:= NIL;
                VideoMemory:= NIL;
                FHandle:= 0;
                exit;
        end;

        // TODO Move window to screen center
        //MoveWindow(Handle, 400, 100, 100, 100, false);
        SetForegroundWindow(FHandle);
        ShowWindow(FHandle, SW_SHOWDEFAULT);

        fheight:=OverlayHeight;
        fWidth:=OverlayWidth;
        fsourcerect:=rect(0,0,fwidth,fheight);

end;

destructor TDDrawXOverlay.Destroy;
begin
 FDirectDrawClipper:= NIL;
 FDirectDrawOverlay:= NIL;
 FDirectDrawSurface:= NIL;
end;

function TDDrawXOverlay.UpdateOverlay(SourceRect,DestinationRect:Prect;
                       OverlayColorKey:DWORD):HRESULT;
var DDOverlayFX:TDDOVERLAYFX;

begin
 if (FDirectDrawSurface = NIL) or (FDirectDrawOverlay = NIL) then
  result:=DDERR_GENERIC else
  begin
   ZeroMemory(@DDOverlayFX, sizeof(DDOVERLAYFX));
   DDOverlayFX.dwSize:= sizeof(DDOVERLAYFX);
   DDOverlayFX.dckDestColorkey.dwColorSpaceLowValue:= OverlayColorKey;
   DDOverlayFX.dckDestColorkey.dwColorSpaceHighValue:= OverlayColorKey;
   result:=FDirectDrawOverlay.UpdateOverlay(SourceRect, FDirectDrawSurface, DestinationRect, DDOVER_KEYDESTOVERRIDE or DDOVER_SHOW, @DDOverlayFX);
  end;
end;

function TDDrawXOverlay.UpdateOverlay(DestinationRect:Prect;OverlayColorKey:DWORD):HRESULT;
begin
 UpdateOverlay(@fSourceRect,DestinationRect,OverlayColorKey);
end;

function TDDrawXOverlay.PaintColorKey(WindowRect:TRECT;OverlayColorKey:DWORD):HRESULT;
var DDBLTFX:TDDBltFX;
begin
 if (FDirectDrawSurface = NIL) or (FDirectDrawClipper = NIL) then
  result:=DDERR_GENERIC else
 begin
        ZeroMemory(@DDBltFX, sizeof(DDBLTFX));
        DDBltFX.dwSize:= sizeof(DDBLTFX);
        DDBltFX.dwFillColor:= OverlayColorKey;

        FDirectDrawSurface.SetClipper(FDirectDrawClipper);
        FDirectDrawSurface.Blt(@WindowRect, NIL, @WindowRect, DDBLT_COLORFILL or DDBLT_WAIT, @DDBltFX);
        FDirectDrawSurface.SetClipper(NIL);

        result:=DD_OK;
 end;
end;

end.
