unit ModBetadisk;

interface

type
    TBetadisk=class
               private
                  RegStatus,
                  RegCom:Byte;
                  RegTrack:Shortint;
                  RegSect,
                  RegData,
                  System:Byte;
                  StepDirect:Shortint;
                  TrackReal:array[0..3] of byte;
                  reserved:array[0..2] of byte;
                  DiskBuf: array[0..$FF] of byte;
                  DskFileName: String;
                  Str: File;
                  DskIndexCounter,
                  DskCountDatLost: Byte;
                  CntData,DskDataSize: Integer;
                  CntReady: Word;
                  function getfa(S:String):integer;
                  function DiskPosition(Sect:Word):Longint;
                  procedure SetStateStep;
                  procedure OpCom;
                  procedure StepRear;
                  procedure OpReadSector;
                  procedure OpWriteSector;
               public
                Disks:array[0..3] of string;
                procedure DiskVG(OperIO:Byte;Var DataIO:Byte);
                constructor create;
               end;

var betadisk: TBetadisk;

implementation uses sysutils;

const
      FormatDatLen             = 1;
      Ready          : Boolean = True;
      ReadIndexTrack : Boolean = False;
      DskStatus      : Byte    = 00;

      DskIndex       : array[0..4] of byte = (0,1,1,0,0);


function TBetadisk.getfa(S:String):integer;
begin
 if fileexists(s) then result:=$20 else result:=-1;
end;

function TBetadisk.DiskPosition(Sect:Word):Longint;
begin
 DiskPosition:=((RegTrack shl 5) or (System and $10 xor $10) or Sect) shl $08;
end;

procedure TBetadisk.SetStateStep;
begin
        if RegTrack<0 then
              begin
                TrackReal[System and $03]:=0;
                RegTrack:=0;
              end;
        if RegTrack>$4F then
              begin
                TrackReal[System and $03]:=$4F;
                RegTrack:=$4F;
              end;

        RegStatus:=DskStatus and $40;
        if RegCom and $08>0 then RegStatus:=RegStatus or $20;
        if RegTrack=0 then RegStatus:=RegStatus or $04;
end;

procedure TBetadisk.OpCom;
begin
 DskCountDatLost:=$00;
 CntData:=$0000;
 RegStatus:=$03;
 if not Ready then
  begin
   RegStatus:=$01;
   CntReady:=$10;
  end;
end;

procedure TBetadisk.StepRear;
begin
 if RegTrack>0 then
  begin
   dec(RegTrack);
   TrackReal[System and $03]:=RegTrack;
  end;
  StepDirect:=-1;
  SetStateStep;
end;

procedure TBetadisk.OpReadSector;
var numread:integer;
	Position:longint;
begin
 if (RegSect>$10) or (RegTrack<>TrackReal[System and $03]) or
    (DskStatus and $04=0) then
  begin
   RegStatus:=$10; {OpNotFound}
   exit;
  end;

 Position:=DiskPosition(RegSect-1);

 seek(Str,Position);
 blockread(Str,diskbuf,sizeof(diskbuf),numread);

 if Position=2048 then diskbuf[227]:=16; {BUG !!! at pos $8e3 must be $10 ??}

 if numread<>sizeof(diskbuf) then RegStatus:=$08 {OpContSum}
  else
   begin
    DskDataSize:=$FF;
    RegData:=DiskBuf[0];
    OpCom;
   end;
end;

procedure TBetadisk.OpWriteSector;
begin
 if DskStatus and $40>0 then
  begin
   RegStatus:=$40; {OpWrProt}
   exit;
  end;
 if (RegSect>$10) or (RegTrack<>TrackReal[System and $03]) or
    (DskStatus and $04=0) then RegStatus:=$10 {OpNotFound}
   else
   begin
    DskDataSize:=$0100;
    OpCom;
   end;
end;

procedure TBetadisk.DiskVG(OperIO:Byte;Var DataIO:Byte);

var numread,numwritten,
    i,attr:integer;
    IntrqDrq:Word;
    Intrq,Drq:Byte;
begin
        if RegStatus and $01>0 then
         begin
          dec(DskCountDatLost);
          if dskcountdatlost=0 then RegStatus:=$04;
         end;
        if CntReady>0 then
         begin dec(CntReady);if (CntReady=0) then RegStatus:=$03; end;

        case OperIO of
         $0: begin
                DataIO:=RegStatus;
                if RegCom and $80>0 then exit;
                dec(DskIndexCounter);
                if DskIndexCounter and $E>0 then DataIO:=DataIO or $02;
              end;
         $1: begin
                if RegStatus and $01=0 then
                begin
                        if (DataIO and $F0)=$D0 then exit;
                        RegCom:=DataIO;
                        case RegCom shr 4 of
                         $0: begin
                                TrackReal[System and $03]:=0;
                                RegTrack:=0;
                                StepDirect:=-1;
                                SetStateStep;
                              end;
                         $1: begin
                                TrackReal[System and $03]:=RegData;
                                RegTrack:=RegData;
                                if RegData-RegTrack<0 then StepDirect:=-1;
                                if RegData-RegTrack>0 then StepDirect:=1;
                                SetStateStep;
                             end;
                          $2,
                          $3,
                          $4,
                          $5:begin
                              if ( (RegCom shr 4) in [2,3]) and (StepDirect=-1) then
                               begin StepRear;exit;end;
                                if RegTrack>0 then
                                 begin
                                  inc(RegTrack);
                                  TrackReal[System and $03]:=RegTrack;
                                 end;
                                StepDirect:=1;
                                SetStateStep;
                              end;
                         $6,
                         $7: StepRear;
                         $8,
                         $9: OpReadSector;
                         $A,
                         $B: OpWriteSector;
                         $C: begin
                                DskDataSize:=$0005;
                                RegData:=1;
                                if ReadIndexTrack then RegData:=RegTrack;
                                OpCom;
                             end;
                         $E:;
                         $F: begin
                                if DskStatus and $40>0 then
                                  RegStatus:=$40 {OpWrProt}
                                else
                                begin
                                 DskDataSize:=FormatDatLen;
                                 OpCom;
                                end;
                             end;
                        end;
                end;
               end;
         $2: DataIO:=RegTrack;
         $3: if RegStatus and $01=0 then RegTrack:=DataIO;
         $4: DataIO:=RegSect;
         $5: if RegStatus and $01=0 then RegSect:=DataIO;
         $6: begin
                if RegStatus and $01>0 then
                 begin
                        case RegCom shr 4 of
                         $8,
                         $9: begin
                                DataIO:=RegData;
                                DskCountDatLost:=$10;
                                if CntData<DskDataSize then
                                 begin
                                  inc(cntData);
                                  RegData:=DiskBuf[CntData];
                                 end
                                else begin
                                        if RegCom and $10>0 then
                                         begin
                                                inc(RegSect);
                                                OpReadSector;
                                         end else RegStatus:=$00; {OpOk}
                                end
                              end;
                          $C: begin
                                DataIO:=RegData;
                                DskCountDatLost:=$10;
                                if CntData<DskDataSize then
                                 begin
                                  RegData:=DskIndex[CntData];
                                  inc(CntData);
                                 end
                                else RegStatus:=$00; {OpOk}
                               end;
                        end
                end else DataIO:=RegData;
                end;
         $7: begin
                if (RegStatus and $01>0) then
                 begin
                        case RegCom shr 4 of
                         $A,
                         $B: begin
                                DiskBuf[CntData]:=DataIO;
                                RegData:=DataIO;inc(CntData);
                                DskCountDatLost:=$10;
                                if CntData>=DskDataSize then
                                 begin
                                        seek(Str,DiskPosition(RegSect-1));
                                        blockwrite(Str,Diskbuf,sizeof(Diskbuf),numwritten);
                                        if numwritten<>sizeof(DiskBuf) then
                                         begin
                                          RegStatus:=$08; {OpContSum}
                                          exit;
                                         end;
                                        if (RegCom and $10>0) then
                                         begin
                                                inc(RegSect);
                                                OpWriteSector;
                                        end else RegStatus:=$00; {OpOk}
                                end
                              end;
                          $F: begin
                                RegData:=DataIO;
                                DskCountDatLost:=$10;
                                inc(cntData);
                                if CntData>=DskDataSize then
                                begin
                                        fillchar(DiskBuf,sizeof (DiskBuf),0);
                                        if DskStatus and $04>0 then
                                        begin
                                                seek(Str,DiskPosition(0));
                                                for i:=0 to $10-1  do blockwrite(Str,DiskBuf,sizeof(Diskbuf));
                                        end else
                                        begin
                                         {$i+} assignFile(str,DskFileName);filemode:=2;rewrite(str,1);{$i+}
                                         if ioresult<>0 then begin RegStatus:=$00; {OpOk}exit;end;
                                         for i:=0 to $A00-1 do blockwrite(Str,DiskBuf,sizeof(Diskbuf));
                                         DskStatus:=DskStatus or $4;
                                        end;
                                        RegStatus:=$00; {OpOk}
                                end;
                           end;
                       end
                end else
                        RegData:=DataIO;
          end;
        $8: begin
                {if RegStatus and 32>0 then DRQ:=$40 else DRQ:=0;
                if Regstatus and 64>0 then Intrq:=$80 else Intrq:=0;
                Dataio:=DRQ or intrq;}
                IntrqDrq:=$BF;
                if RegStatus and $01>0 then IntrqDrq:=$3F;
                if RegStatus and $02>0 then IntrqDrq:=$7F;
                DataIO:=IntrqDrq;
             end;
         $9: begin
                if (RegStatus and $01>0) and (RegCom and $80>0) then
                 begin
                  RegStatus:=$08; {OpContSum}
                  exit;
                 end;
                System:=DataIO;
                if (System xor DskStatus) and $03>0 then
                 begin
                        DiskVG($B,DataIO);
                        DiskVG($A,DataIO);
                 end;
               end;
          $A: begin
                if DskStatus and $80>0 then exit;
                DskStatus:=System and $03;
                DskFileName:=Disks[DskStatus];
                Attr:=GetFA(DskFileName);
                if Attr<>-1 then
                begin
                        Attr:=Attr and $01;
                        DskStatus:=DskStatus or (Attr shl 6);
                        {$i+}assignFile(str,DskFilename);filemode:=0;reset(str,1);{$i+}
                        if ioresult=0 then DskStatus:=DskStatus or $04;
                end;
                DskStatus:=DskStatus or $80;
               end;
         $B: begin
                if DskStatus and $80=0 then exit;
                if DskStatus and $04>0 then close(Str);
                DskStatus:=$00;
              end;
         $C: begin
                RegStatus:=$24;
                RegCom:=$00;
                RegTrack:=$00;
                RegSect:=$01;
                RegData:=$00;
                System:=$3C;
                StepDirect:=shortint($FF);
                if (DskStatus and $80>0) and (DskStatus and $03>0) then
                 begin
                        DiskVG($B,DataIO);
                        DiskVG($A,DataIO);
                 end;
            end;
        end;
end;


constructor TBetadisk.create;
var i:byte;
begin
 for i:=low(disks) to high(disks) do disks[i]:='';
end;

end.
