unit USetup;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ImgList, AgOpenDialog, ExtCtrls,
  modtape;

type
  TfrmSetup = class(TForm)
    PCOptions: TPageControl;
    tsGeneric: TTabSheet;
    tsVideo: TTabSheet;
    tsRoms: TTabSheet;
    tsHardware: TTabSheet;
    tsBetadisk: TTabSheet;
    tsJoystick: TTabSheet;
    tsSound: TTabSheet;
    tsTape: TTabSheet;
    btnOK: TButton;
    btnCancel: TButton;
    gbSound: TGroupBox;
    cbSpeaker2: TCheckBox;
    cbAY8912: TCheckBox;
    gbKeyboard: TGroupBox;
    lblUp: TLabel;
    lblDown: TLabel;
    lblLeft: TLabel;
    lblRight: TLabel;
    lblFire: TLabel;
    HKLeft: THotKey;
    HKUp: THotKey;
    HKDown: THotKey;
    HKRight: THotKey;
    HKFire: THotKey;
    ilItems: TImageList;
    lvDisks: TListView;
    btnInsert: TButton;
    btnEject: TButton;
    OpenDialog: TAgOpenDialog;
    EnhListView1: TListView;
    btnSet: TButton;
    btnClear: TButton;
    cbDisplay: TComboBox;
    cbRealborder: TCheckBox;
    edFrameSkip: TEdit;
    grpDisplaySize: TRadioGroup;
    upFrameskip: TUpDown;
    cbRealflash: TCheckBox;
    Label1: TLabel;
    lblDisplay: TLabel;
    grpEmulationSpeed: TRadioGroup;
    rgModel: TRadioGroup;
    gbAdditional: TGroupBox;
    cbInterface: TCheckBox;
    cbMultiface128: TCheckBox;
    cbBetadisk: TCheckBox;
    cbReset: TCheckBox;
    lvTape: TListView;
    btnInsertTape: TButton;
    btnEjectTape: TButton;
    cbSound: TCheckBox;
    procedure btnInsertClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnInsertTapeClick(Sender: TObject);
    procedure btnEjectTapeClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnEjectClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure lvTapeClick(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
    procedure InsertDisk(Drive:Byte;FName:String);
    procedure RefreshTables;
  end;

var
  frmSetup: TfrmSetup;

implementation uses modMain,modBetadisk;

{$R *.DFM}



procedure TfrmSetup.InsertDisk(Drive:Byte;FName:String);
begin
 if assigned(lvDisks.Items[Drive]) then
  begin
   if fname='' then fname:='<none>';
   
   if lvDisks.Items[Drive].SubItems.count>0 then
    lvDisks.Items[Drive].subitems[0]:=FName else
    lvDisks.Items[Drive].subitems.add(FName);
    if fname='<none>' then fname:='';
    betadisk.Disks[Drive]:=Fname;
  end;
end;

procedure TfrmSetup.btnEjectClick(Sender: TObject);
begin
 if lvdisks.SelCount>0 then
   insertdisk(ord(lvdisks.Selected.caption[1])-ord('A'),'<none>');
end;

procedure TfrmSetup.btnInsertClick(Sender: TObject);
begin
 opendialog.filter:='TRD files (*.trd)|*.trd';
 if lvdisks.SelCount>0 then
  if opendialog.execute then
   insertdisk(ord(lvdisks.Selected.caption[1])-ord('A'),opendialog.filename);
end;

procedure TfrmSetup.FormCreate(Sender: TObject);
begin
// tape:=ttapeinfo.Create;
end;

procedure TFrmSetup.RefreshTables;
var i:integer;
begin
  lvtape.Items.Clear;
  if tape.count>0 then
   for i:=0 to tape.count do
    with lvtape.Items.Add,tape.list[i] do
     begin
      caption:=name;
      imageindex:=2;
      subitems.add(typ);
      subitems.add(inttostr(real.start));
     end;
  for i:=0 to 3 do insertdisk(i,betadisk.disks[i]);
end;

procedure TfrmSetup.btnInsertTapeClick(Sender: TObject);
begin
 opendialog.filter:='TAP files (*.tap)|*.tap';
 if opendialog.Execute then
 begin
  tape.tapename:=opendialog.filename;
  RefreshTables;
 end;
end;

procedure TfrmSetup.btnEjectTapeClick(Sender: TObject);
begin
 tape.tapename:='';
 refreshtables;
end;

procedure TfrmSetup.FormShow(Sender: TObject);
begin
 refreshtables;

     Case glInterruptDelay of
      40: // 40ms delay = 50% Spectrum speed
        grpEmulationSpeed.ItemIndex := 0;
      20: //20ms delay = 100% Spectrum speed
        grpEmulationSpeed.ItemIndex := 1;
      10: //10ms delay = 200% Spectrum speed
        grpEmulationSpeed.ItemIndex := 2;
       0: // 0 delay = run as fast as possible
        grpEmulationSpeed.ItemIndex := 3;
       else
        grpEmulationSpeed.ItemIndex := 1;
    End;

    rgModel.Itemindex:=glEmulatedModel;

    {$IFDEF USE_SOUND}
      cbsound.checked := gbSoundEnabled;
      cbSpeaker2.checked:=gbSpeakerEnabled;
      cbAy8912.checked:=gbAY8912Enabled;
    {$ELSE}
      chkSound.Enabled := False;
    {$ENDIF}

 // Display

     If glDisplayWidth = 256 Then
    begin
      grpDisplaySize.ItemIndex := 0
    end
    Else If glDisplayWidth = 512 Then
    begin
      grpDisplaySize.ItemIndex := 1
    end
    Else If glDisplayWidth = 768 Then
    begin
      grpDisplaySize.ItemIndex := 2;
    End;

  cbDisplay.ItemIndex:=byte(glDisplayMode);
  cbRealborder.checked:=glRealBorder;

 HkUp.hotkey:=glJoystick.up;
 HkDown.hotkey:=glJoystick.down;
 HkLeft.hotkey:=glJoystick.left;
 HKRight.hotkey:=glJoystick.right;
 HKFire.hotkey:=glJoystick.fire;
 cbRealFlash.checked:=glEmulatedFlash;
end;

procedure TfrmSetup.btnOKClick(Sender: TObject);
begin
    If grpEmulationSpeed.ItemIndex = 0 Then
        glInterruptDelay := 40
    Else If grpEmulationSpeed.ItemIndex = 1 Then
        glInterruptDelay := 20
    Else If grpEmulationSpeed.ItemIndex = 2 Then
        glInterruptDelay := 10
    Else If grpEmulationSpeed.ItemIndex = 3 Then
        glInterruptDelay := 0;
    SaveSetting('InterruptDelay', IntToStr(glInterruptDelay));
    
    glEmulatedModel := rgModel.ItemIndex;
    SaveSetting('EmulatedModel', IntToStr(glEmulatedModel));

    {$IFDEF USE_SOUND}
    SaveSetting('SoundEnabled', IntToStr(byte(cbsound.Checked)));
    SaveSetting('SpeakerEnabled', IntToStr(byte(cbSpeaker2.checked)));
    SaveSetting('AY8912Enabled', IntToStr(byte(cbAY8912.checked)));

    gbSpeakerenabled:= cbSpeaker2.checked;
    gbAY8912enabled:= cbAY8912.checked;
    If gbSoundEnabled Then
    begin
      If cbSound.checked = false Then CloseWaveOut;
    end
    Else
    begin
      If cbSound.checked = true Then
       gbSoundEnabled := InitializeWaveOut;
    End;
    {$ENDIF}
 SetDisplay(cbDisplay.itemindex,cbRealBorder.checked,cbRealFlash.checked,strtoint(edFrameSkip.text));

 case grpDisplaySize.ItemIndex of
  0: SetDisplaySize(256, 192);
  1: SetDisplaySize(512, 384);
  2: SetDisplaySize(768, 576);
  Else SetDisplaySize(256, 192);
 end;

 SetKempston(HkUp.hotkey,HkDown.hotkey,HkLeft.hotkey,HKRight.hotkey,HKFire.hotkey);
 close;
end;

procedure TfrmSetup.btnCancelClick(Sender: TObject);
begin
 close;
end;

procedure TfrmSetup.lvTapeClick(Sender: TObject);
begin
  if lvtape.SelCount>0 then
    seek(tape.handle,strtoint(lvtape.Selected.SubItems[1]));
//  close;
end;

end.
 